#include "bits/stdc++.h"
using namespace std;
#define LL long long
#define int LL
#define PB push_back
#define VI vector<int>
#define FOR(i,a,b) for(int i = (a); i <= (b); i++)
#define REP(i,n) FOR(i, 0, (int)n - 1)
#define PII pair<int,int>
#define ALL(x) (x).begin(), (x).end()
#define SZ(x) ((int)(x).size())
#define st first
#define nd second

template<class C> void mini(C & a4, C b4){a4 = min(a4, b4);}
template<class C> void maxi(C & a4, C b4){a4 = max(a4, b4);}

template<class TH> void _dbg(const char * sdbg, TH h){
	cerr<<sdbg<<'='<<h<<endl;
}
template<class TH, class... TA> void _dbg(const char * sdbg, TH h, TA... a){
	while(*sdbg!=',')
		cerr<<*sdbg++;
	cerr<<'='<<h<<",";
	_dbg(sdbg + 1, a...);
}
template<class T> ostream & operator<<(ostream & os, vector<T> V){
	os<<"[";for(auto vv: V) os <<vv<<","; return os <<"[";
}
template<class L, class R> ostream & operator<<(ostream & os , pair<L,R> P){
	return os << "(" << P.st <<","<<P.nd<<")";
}
#ifdef LOCAL
#define debug(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
#else
#define debug(...) (__VA_ARGS__)
#define cerr if(0) cout
#endif 
vector<VI> graph;
VI sz;

int dfs(int x, int p){	
	int sc = 1;
	for(int a: graph[x]){
		if(a == p)
			continue;
		sc += dfs(a, x);
	}
	return sz[x] = sc;
}
struct Point{
	int x, y;
	int idx;
};

Point & operator -=(Point & lhs, Point rhs){
	lhs.x -= rhs.x;
	lhs.y -= rhs.y;
	return lhs;
}
ostream & operator <<(ostream & os, Point lhs){
	return os <<"("<<lhs.x<<", "<<lhs.y<<", "<<lhs.idx<<")";
}

int sq(int x){
	return x * x;
}
int dist(const Point & lhs, const Point & rhs){
	return sq(lhs.x - rhs.x) + sq(lhs.y - rhs.y);
}
int crossProd(Point lhs, Point rhs){
	return lhs.x * rhs.y - lhs.y * rhs.x;
}
vector<PII> ans;

void sortPts(vector<Point> & lhs, Point cur){
	if(lhs.empty()){
		return;
	}
	int idx = rand() % SZ(lhs);	
	vector<Point> left;
	vector<Point> right;
	Point pivot = lhs[idx];
	pivot -= cur;
	for(Point p: lhs){
		p -= cur;
		if(crossProd(p, cur) < -1){
			left.PB(p);
		} else{
			right.PB(p);
		}
	}
	sort(ALL(left), [&](Point lhs, Point rhs){
		lhs -= cur;
		rhs -= cur;
		return crossProd(lhs, rhs) < 0;
	});
	sort(ALL(right), [&](Point lhs, Point rhs){
		lhs -= cur;
		rhs -= cur;
		return crossProd(lhs, rhs) < 0;
	});
	left.PB(lhs[idx]);
	left.insert(left.end(), ALL(right));
	lhs = left;
}

int tup(int x, int p, vector<Point> pts, Point father){		
	debug(x, p, pts, father);
	if(x != 0)
		sort(ALL(pts), [&](Point lhs, Point rhs){
			return dist(lhs, father) > dist(rhs, father);
		});
	Point cur = pts.back();
	pts.pop_back();
	for(int a: graph[x]){
		if(a == p)
			continue;
		vector<Point> acc(pts.end() - sz[a], pts.end());
		pts.resize(SZ(pts) - sz[a]);
		int his = tup(a, x, acc, cur);
		ans.PB({cur.idx, his});
	}
	return cur.idx;
}

int32_t main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin>>n;
	graph.resize(n);
	sz.resize(n);
	REP(i, n - 1){
		int a,b;
		cin>>a>>b;
		graph[a].PB(b);
		graph[b].PB(a);
	}
	vector<Point> pts(n);
	REP(i, n){
		int x,y;
		cin>>x>>y;
		pts[i] = {x, y, i};
	}
	dfs(0, -1);
	tup(0, -1, pts, Point{0,0,-1});
	for(PII p: ans){
		cout<<p.st<<" "<<p.nd<<"\n";
	}
}
