#include "bits/stdc++.h"
using namespace std;
#define LL long long
#define int LL
#define PB push_back
#define VI vector<int>
#define FOR(i,a,b) for(int i = (a); i <= (b); i++)
#define REP(i,n) FOR(i, 0, (int)n - 1)
#define PII pair<int,int>
#define ALL(x) (x).begin(), (x).end()
#define SZ(x) ((int)(x).size())
#define st first
#define nd second

template<class C> void mini(C & a4, C b4){a4 = min(a4, b4);}
template<class C> void maxi(C & a4, C b4){a4 = max(a4, b4);}

template<class TH> void _dbg(const char * sdbg, TH h){
	cerr<<sdbg<<'='<<h<<endl;
}
template<class TH, class... TA> void _dbg(const char * sdbg, TH h, TA... a){
	while(*sdbg!=',')
		cerr<<*sdbg++;
	cerr<<'='<<h<<",";
	_dbg(sdbg + 1, a...);
}
template<class T> ostream & operator<<(ostream & os, vector<T> V){
	os<<"[";for(auto vv: V) os <<vv<<","; return os <<"[";
}
template<class L, class R> ostream & operator<<(ostream & os , pair<L,R> P){
	return os << "(" << P.st <<","<<P.nd<<")";
}
#ifdef LOCAL
#define debug(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
#else
#define debug(...) (__VA_ARGS__)
#define cerr if(0) cout
#endif 

void remove(int a, int d, int x, int y) {
	for (int i = 0; i < V[a][d].size(); i++) {
		if (V[a][d][i] == {x, y}) {
			swap(V[a][d][i], V[a][d].back());
			V[a][d].pop_back();
			i--;
			continue;
		}
	}	
}

void insert(int x, int y, int d) {
	int a = find(a);
	V[a][d].push_back({x, y});
	V[b][d].push_back({x, y}});
}

bool DFS(int w, int goal, int d) {
	if (w == goal) return true;
	
	for (int i = 0; i < V[w].size(); i++) {
		int u = find(V[w][i].second);
		if (!vis[u] && DFS(u)) {
			return true;
		}
	}
	
	return false;
}

bool isPath(int x, int y, int d) {
	int a = find(x);
	int b = find(y);
	if (a == b) return true;
	for (int w : reps) {
		vis[w] = false;
	}
	return DFS(a, b, d);
}

set<int> currentEdges;
void preprocess(int from) {
	
	
	for (int i = from; i % S
	
}

int32_t main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> q;
	
	for (int i = 1; i <= q; i++) {
		if (i % S == 0) {
			preprocess(i);
		}
		cin >> type;
		if (type == 0) {
			cin >> x >> y >> v;
			
			for (int d = v; d < 10; d++) {
				insert(x, y, d);
				insert(y, x, d);
			}
		} else {
			cin >> x >> y;
			for (int d = 0; d < 10; d++) {
				int a = find(x);
				int b = find(y);
				remove(a, d, {x, y});
				remove(b, d, {y, x});
			}	
		} else {
			cin >> x >> y;
			for (int d = 0; d < 10; d++) {
				bool found = false;
				if (isPath(x, y, d)) {
					cout << d << endl;
					found = true;
					break;
				}
				if (!found) {
					cout << -1 << endl;
					continue;
				}
			}
		}
	}
	
	return 0;
}
